diff -udNr xdvik//dvi-draw.c pxdvik//dvi-draw.c
--- xdvik//dvi-draw.c	2009-06-22 23:29:44.000000000 +0900
+++ pxdvik//dvi-draw.c	2010-07-25 15:03:46.225418563 +0900
@@ -57,6 +57,7 @@
 #include "special.h"
 #include "tfmload.h"
 #include "read-mapfile.h"
+#include "ptexmap.h"
 #include "my-snprintf.h"
 #include "kpathsea/tex-file.h"
 #include "mag.h"
@@ -980,7 +981,12 @@
 static const char *dvi_table2[] = {
     "FNT1", "FNT2", "FNT3", "FNT4", "XXX1", "XXX2", "XXX3", "XXX4",
     "FNTDEF1", "FNTDEF2", "FNTDEF3", "FNTDEF4", "PRE", "POST", "POSTPOST",
-    "SREFL", "EREFL", NULL, NULL, NULL, NULL
+    "SREFL", "EREFL", NULL, NULL, NULL,
+#ifdef PTEX
+    "DIRECTION"
+#else /* !PTEX */
+    NULL
+#endif /* !PTEX */
 };
 
 static void
@@ -1105,6 +1111,142 @@
     return n;
 }
 
+extern	double	bbox_matrix[2][2];
+extern	Boolean	bbox_scaled, bbox_rotated;
+
+static void moveH(int dir, long dx)
+{
+    if (TATE) {
+	DVI_H -= dx * bbox_matrix[1][0];
+	DVI_V += dx * bbox_matrix[0][0];
+    } else {
+	DVI_H += dir * dx * bbox_matrix[0][0];
+	DVI_V += dir * dx * bbox_matrix[1][0];
+    }
+    PXL_V = pixel_conv(DVI_V);
+}
+
+static void moveV(int dir, long dy)
+{
+    if (TATE) {
+	DVI_H -= dy * bbox_matrix[1][1];
+	DVI_V += dy * bbox_matrix[0][1];
+    } else {
+	DVI_H += dir * dy * bbox_matrix[0][1];
+	DVI_V += dir * dy * bbox_matrix[1][1];
+    }
+    PXL_V = pixel_conv(DVI_V);
+}
+
+#define PUSH_POSITION do { \
+	dvi_h_sav = DVI_H; \
+	dvi_v_sav = DVI_V; \
+	pxl_v_sav = PXL_V; } while (0)
+#define POP_POSITION do { \
+	DVI_H = dvi_h_sav; \
+	DVI_V = dvi_v_sav; \
+	PXL_V = pxl_v_sav; } while (0)
+#define DEFINE_POSITION_VAL \
+	long dvi_h_sav, dvi_v_sav, pxl_v_sav
+
+#ifndef   WORDS_BIGENDIAN
+#define EXTREME_LEFT_BIT   (1 << 0)
+#define EXTREME_RIGHT_BIT  ((bmUnitT)(1 << (BMBITS-1)))
+#define SHIFT_RIGHT(a)     ((a) <<= 1)
+#else  /* WORDS_BIGENDIAN */
+#define EXTREME_LEFT_BIT   ((bmUnitT)(1 << (BMBITS-1)))
+#define EXTREME_RIGHT_BIT  (1 << 0)
+#define SHIFT_RIGHT(a)     ((a) >>= 1)
+#endif /* WORDS_BIGENDIAN */
+
+static	void
+bbox_scale_bitmap(struct glyph *g)
+{
+    bmUnitT *new_ptr;
+    int xmax, ymax, xmin, ymin, x, y;
+    double d;
+ 
+    if (g->bitmap3.bits) {
+	if (g->matrix[0][0] == (float) bbox_matrix[0][0]
+	    && g->matrix[0][1] == (float) bbox_matrix[0][1]
+	    && g->matrix[1][0] == (float) bbox_matrix[1][0]
+	    && g->matrix[1][1] == (float) bbox_matrix[1][1])
+	    return;
+	else
+	    free(g->bitmap.bits);
+    } else {
+	g->bitmap3 = g->bitmap;
+	g->x3 = g->x;
+	g->y3 = g->y;
+    }
+
+    xmax = ymax = xmin = ymin = 0;
+    x = g->bitmap3.w * bbox_matrix[0][0];
+    y = g->bitmap3.w * bbox_matrix[1][0];
+    if (xmax < x) xmax = x;
+    else if (xmin > x) xmin = x;
+    if (ymax < y) ymax = y;
+    else if (ymin > y) ymin = y;
+    x = g->bitmap3.w * bbox_matrix[0][0] + g->bitmap3.h * bbox_matrix[0][1];
+    y = g->bitmap3.w * bbox_matrix[1][0] + g->bitmap3.h * bbox_matrix[1][1];
+    if (xmax < x) xmax = x;
+    else if (xmin > x) xmin = x;
+    if (ymax < y) ymax = y;
+    else if (ymin > y) ymin = y;
+    x = g->bitmap3.h * bbox_matrix[0][1];
+    y = g->bitmap3.h * bbox_matrix[1][1];
+    if (xmax < x) xmax = x;
+    else if (xmin > x) xmin = x;
+    if (ymax < y) ymax = y;
+    else if (ymin > y) ymin = y;
+    xmin--; ymin--; xmax++; ymax++;
+
+    d = bbox_matrix[0][0] * bbox_matrix[1][1]
+	- bbox_matrix[0][1] * bbox_matrix[1][0];
+
+    g->x = g->x3 * bbox_matrix[0][0] + g->y3 * bbox_matrix[0][1] - xmin;
+    g->y = g->x3 * bbox_matrix[1][0] + g->y3 * bbox_matrix[1][1] - ymin;
+    g->matrix[0][0] = (float) bbox_matrix[0][0];
+    g->matrix[0][1] = (float) bbox_matrix[0][1];
+    g->matrix[1][0] = (float) bbox_matrix[1][0];
+    g->matrix[1][1] = (float) bbox_matrix[1][1];
+
+    free_bitmap2(g);
+    g->bitmap.w = xmax - xmin + 1;
+    g->bitmap.h = ymax - ymin + 1;
+    alloc_bitmap(&g->bitmap);
+    clear_bitmap(&g->bitmap);
+
+    new_ptr = (bmUnitT *) g->bitmap.bits;
+    for (y = ymin; y <= ymax; y++) {
+	register bmUnitT m, *cp;
+
+	cp = new_ptr;
+	m = EXTREME_LEFT_BIT;
+	for (x = xmin; x <= xmax; x++) {
+	    int bx, by;
+	    bx = (x * bbox_matrix[1][1] - y * bbox_matrix[0][1]) / d;
+	    by = (y * bbox_matrix[0][0] - x * bbox_matrix[1][0]) / d;
+	    if (bx >= 0 && bx < g->bitmap3.w
+		&& by >= 0 && by < g->bitmap3.h
+		&& *((bmUnitT *)g->bitmap3.bits
+		     + by * (g->bitmap3.bytes_wide / BMBYTES) + bx / BMBITS)
+#ifndef	WORDS_BIGENDIAN
+		& (1 << (bx % BMBITS)))
+#else
+		& (1 << (BMBITS - 1 - bx % BMBITS)))
+#endif
+		    *cp |= m;
+	    if (m == EXTREME_RIGHT_BIT) {
+		m = EXTREME_LEFT_BIT;
+		++cp;
+	    }
+	    else SHIFT_RIGHT(m);
+	}
+	new_ptr = ADD(new_ptr, g->bitmap.bytes_wide);
+    }
+}
+
 static void
 shrink_glyph(struct glyph *g)
 {
@@ -1195,6 +1337,89 @@
 	print_bitmap(&g->bitmap2);
 }
 
+#ifdef PTEX
+void
+rotate_bitmap(struct bitmap *bm)
+{
+      struct bitmap new_bm;
+      bmUnitT *old_ptr, *new_ptr, *cp;
+      int    x, y;
+      bmUnitT m1, m2;
+ 
+      new_bm.h = bm->w;
+      new_bm.w = bm->h;
+      alloc_bitmap(&new_bm);
+      clear_bitmap(&new_bm);
+      old_ptr = ADD(bm->bits, bm->bytes_wide * bm->h);
+      new_ptr = (bmUnitT *)new_bm.bits;
+
+      m1 = EXTREME_LEFT_BIT;
+      for (y = 0; y < bm->h; y++) {
+	old_ptr = SUB(old_ptr, bm->bytes_wide);
+	cp = old_ptr;
+	m2 = EXTREME_LEFT_BIT;
+	for (x = 0; x < bm->w; x++) {
+	  if (*cp & m2)
+	    *ADD(new_ptr, x*new_bm.bytes_wide) |= m1;
+	  if (m2 == EXTREME_RIGHT_BIT) {
+	    m2 = EXTREME_LEFT_BIT;
+	    ++cp;
+	  }
+	  else SHIFT_RIGHT(m2);
+	}
+	if (m1 == EXTREME_RIGHT_BIT) {
+	  m1 = EXTREME_LEFT_BIT;
+	  ++new_ptr;
+	}
+	else SHIFT_RIGHT(m1);
+      }
+
+      free(bm->bits);
+      *bm = new_bm;
+}
+
+
+void
+reverse_rotate_bitmap(struct bitmap *bm)
+{
+      struct bitmap new_bm;
+      bmUnitT *old_ptr, *new_ptr, *cp;
+      int    x, y;
+      bmUnitT m1, m2;
+
+      new_bm.h = bm->w;
+      new_bm.w = bm->h;
+      alloc_bitmap(&new_bm);
+      clear_bitmap(&new_bm);
+      old_ptr = (bmUnitT *)bm->bits;
+      new_ptr = (bmUnitT *)new_bm.bits;
+
+      m1 = EXTREME_LEFT_BIT;
+      for (y = 0; y < bm->h; y++) {
+	cp = old_ptr;
+	old_ptr = ADD(old_ptr, bm->bytes_wide);
+	m2 = EXTREME_LEFT_BIT;
+	for (x = bm->w; x--;) {
+	  if (*cp & m2)
+	    *ADD(new_ptr, x * new_bm.bytes_wide) |= m1;
+	  if (m2 == EXTREME_RIGHT_BIT) {
+	    m2 = EXTREME_LEFT_BIT;
+	    ++cp;
+	  }
+	  else SHIFT_RIGHT(m2);
+	}
+	if (m1 == EXTREME_RIGHT_BIT) {
+	  m1 = EXTREME_LEFT_BIT;
+	  ++new_ptr;
+	}
+	else SHIFT_RIGHT(m1);
+      }
+
+      free(bm->bits);
+      *bm = new_bm;
+}
+#endif /* PTEX */
+
 #ifdef	GREY
 
 #ifdef RGB_ANTI_ALIASING
@@ -1408,6 +1633,7 @@
 				 BMBITS, 0);
 	size = g->image2->bytes_per_line * g->bitmap2.h;
 	g->pixmap2 = g->image2->data = xmalloc(size != 0 ? size : 1);
+	ASSERT(g->pixmap2_gc2 == NULL, "pixmap2_gc2 is not NULL.");
     }
     /* ... and the pixmap used for globals.gc.fore2: */
     if (globals.gc.fore2 != NULL && g->pixmap2_gc2 == NULL) {
@@ -1775,9 +2001,11 @@
 		ch = xone(fp);
 		xskip(fp, (long)ch + (long)xone(fp));
 		break;
+#ifndef PTEX
 	    case M4:	/* unrecognizable */
 		XDVI_FATAL((stderr, "unknown op-code %d", ch));
 		break;
+#endif /* !PTEX */
 	    case M5:	/* doesn't belong */
 		dvi_fmt_error("spcl_scan: shouldn't happen: %s encountered",
 			      dvi_table2[ch - (FNTNUM0 + 64)]);
@@ -1891,6 +2119,37 @@
  *	Routines to print characters.
  */
 
+#ifdef PTEX
+static void
+set_char_rotate_glyph(struct glyph *g, int reverse_rotate)
+{
+    if (g->tdir != TATE) {
+	int tmp;
+	if (!reverse_rotate) {
+	    rotate_bitmap(&g->bitmap);
+	    tmp = g->x;
+	    g->x = g->bitmap.w - g->y;
+	    g->y = tmp;
+	}
+	else {
+	    reverse_rotate_bitmap(&g->bitmap);
+	    tmp = g->x;
+	    g->x = g->y;
+	    g->y = g->bitmap.h - tmp;
+	}
+	g->tdir = TATE;
+	free_bitmap2(g);
+    }
+}
+#endif /* PTEX */
+
+static setcharRetvalT
+common_set_char(
+#ifdef TEXXET
+		wide_ubyte,
+#endif
+		struct glyph *);
+
 setcharRetvalT
 set_char(
 #ifdef TEXXET
@@ -1899,9 +2158,6 @@
 	 wide_ubyte ch)
 {
     struct glyph *g;
-#ifdef TEXXET
-    long dvi_h_sav;
-#endif
 
     if (ch > maxchar)
 	realloc_font(currinf.fontp, (wide_ubyte)ch);
@@ -1930,14 +2186,41 @@
 	    print_char((ubyte) ch, g);
 	currinf.fontp->timestamp = ++current_timestamp;
     }
+#ifdef PTEX
+    set_char_rotate_glyph(g, TATE == currinf.fontp->dir);
+#endif /* PTEX */
+#ifdef TEXXET
+    common_set_char(cmd, g);
+#else
+    return common_set_char(g);
+#endif
+}
 
+static setcharRetvalT
+common_set_char(
 #ifdef TEXXET
-    dvi_h_sav = DVI_H;
-    if (currinf.dir < 0)
-	DVI_H -= g->dvi_adv;
+		wide_ubyte cmd,
+#endif
+		struct glyph *g)
+{
+#ifdef	TEXXET
+    DEFINE_POSITION_VAL;
+    PUSH_POSITION;
+    if (! TATE && currinf.dir < 0)
+	moveH(1, -g->dvi_adv);
 
     if (scan_frame == NULL) {
 #endif
+	if (bbox_scaled)
+	    bbox_scale_bitmap(g);
+	else if (g->bitmap3.bits) {
+	    free(g->bitmap.bits);
+	    g->bitmap = g->bitmap3;
+	    g->bitmap3.bits = NULL;
+	    g->x = g->x3;
+	    g->y = g->y3;
+	    free_bitmap2(g);
+	}
 	
 #ifdef RGB_ANTI_ALIASING
 	if (currwin.shrinkfactor == -1) {
@@ -1979,9 +2262,9 @@
 #ifdef TEXXET
     }
     if (cmd == PUT1 || (resource.omega && cmd == PUT2))
-	DVI_H = dvi_h_sav;
-    else if (currinf.dir > 0)
-	DVI_H += g->dvi_adv;
+	POP_POSITION;
+    else if (TATE || currinf.dir > 0)
+	moveH(1, g->dvi_adv);
     return;
 #else
     return g->dvi_adv;
@@ -2010,6 +2293,33 @@
 #endif
 }
 
+#ifdef PTEX
+setcharRetvalT
+set_char2(
+#ifdef TEXXET
+	 wide_ubyte cmd,
+#endif
+	 wide_ubyte ch)
+{
+    struct glyph *g;
+
+    g = currinf.fontp->kglyph[ch];
+    if (g == NULL || g->bitmap.bits == NULL) {
+	(*currinf.fontp->read_char)(currinf.fontp, ch);
+	g = currinf.fontp->kglyph[ch];
+	free_bitmap2(g);
+	g->tdir = currinf.fontp->dir;
+	if (globals.debug & DBG_BITMAP) print_char((ubyte) ch, g);
+    }
+    set_char_rotate_glyph(g, g->tdir);
+#ifdef TEXXET
+    common_set_char(cmd, g);
+#else
+    return common_set_char(g);
+#endif
+}
+#endif /* PTEX */
+
 setcharRetvalT
 load_n_set_char(
 #ifdef TEXXET
@@ -2058,7 +2368,7 @@
     wide_ubyte oldmaxchar;
     static ubyte c;
 #ifdef TEXXET
-    long dvi_h_sav;
+    DEFINE_POSITION_VAL;
 #endif
 
     if (ch > maxchar)
@@ -2074,9 +2384,9 @@
 #endif
     }
 #ifdef TEXXET
-    dvi_h_sav = DVI_H;
-    if (currinf.dir < 0)
-	DVI_H -= m->dvi_adv;
+    PUSH_POSITION;
+    if (! TATE && currinf.dir < 0)
+	moveH(1, -m->dvi_adv);
     if (scan_frame == NULL) {
 #endif
 	oldinfo = currinf;
@@ -2101,9 +2411,9 @@
 #ifdef TEXXET
     }
     if (cmd == PUT1 || (resource.omega && cmd == PUT2))
-	DVI_H = dvi_h_sav;
-    else if (currinf.dir > 0)
-	DVI_H += m->dvi_adv;
+	POP_POSITION;
+    else if (TATE || currinf.dir > 0)
+	moveH(1, m->dvi_adv);
     return;
 #else
     return m->dvi_adv;
@@ -2140,9 +2450,59 @@
  *	Set rule.  Arguments are coordinates of lower left corner.
  */
 
+static	void
+set_rotated_rule(long h, long w)
+{
+    XPoint points[4];
+
+    points[0].x = PXL_H - currwin.base_x;
+    points[0].y = PXL_V - currwin.base_y;
+#ifdef PTEX
+    if (TATE) {
+	points[1].x = -w * bbox_matrix[1][0];
+	points[1].y = w * bbox_matrix[0][0];
+	points[2].x = h * bbox_matrix[1][1];
+	points[2].y = -h * bbox_matrix[0][1];
+    } else
+#endif /* PTEX */
+    {
+	points[1].x = DIR * w * bbox_matrix[0][0];
+	points[1].y = DIR * w * bbox_matrix[1][0];
+	points[2].x = -h * bbox_matrix[0][1];
+	points[2].y = -h * bbox_matrix[1][1];
+    }
+    points[3].x = -points[1].x;
+    points[3].y = -points[1].y;
+
+    if (--globals.ev.ctr == 0) {
+	if (read_events(EV_NOWAIT) & EV_GE_MAG_GONE) {
+	    /* fprintf(stderr, "longjmp1!\n"); */
+	    longjmp(globals.ev.canit, 1);
+	}
+    }
+#if COLOR
+    if (fg_active != fg_current)
+	do_color_change();
+#endif
+    XFillPolygon(DISP, currwin.win,
+		 htex_inside_href ? globals.gc.high: globals.gc.rule,
+		 points, 4, Convex, CoordModePrevious);
+}
+
 static void
 set_rule(int h, int w)
 {
+    if (bbox_rotated) {
+	set_rotated_rule(h, w);
+	return;
+    }
+    h = h * bbox_matrix[1][1];
+    w = w * bbox_matrix[0][0];
+#ifdef PTEX
+    if (TATE)
+	put_rule(PXL_H, PXL_V, (unsigned int)h, (unsigned int)w);
+    else
+#endif /* PTEX */
 #ifdef TEXXET
     put_rule(PXL_H - (currinf.dir < 0 ? w - 1 : 0), PXL_V - h + 1,
 	     (unsigned int)w, (unsigned int)h);
@@ -2187,7 +2547,7 @@
 #ifdef TEXXET
 	    (*currinf.set_char_p) (ch, ch);
 #else
-	    DVI_H += (*currinf.set_char_p) (ch);
+	    moveH(1, (*currinf.set_char_p) (ch));
 #endif
 	}
 	else if (FNTNUM0 <= ch && ch <= (ubyte) (FNTNUM0 + 63)) {
@@ -2204,7 +2564,7 @@
 #else
 		a = (*currinf.set_char_p) (xone(fp));
 		if (ch != PUT1)
-		    DVI_H += a;
+		    moveH(1, a);
 #endif
 		break;
 
@@ -2219,7 +2579,7 @@
 #else
 		    a = (*currinf.set_char_p) (xnum(fp, 2));
 		    if (ch != PUT2)
-			DVI_H += a;
+			moveH(1, a);
 #endif
 		}
 		break;
@@ -2237,7 +2597,7 @@
 		    ) {
 		    set_rule(pixel_round(xspell_conv(a)), pixel_round(b));
 		}
-		DVI_H += DIR * b;
+		moveH(DIR, b);
 		break;
 
 	    case PUTRULE:
@@ -2261,6 +2621,9 @@
 		DVI_V = OFFSET_Y;
 		PXL_V = pixel_conv(DVI_V);
 		WW = XX = YY = ZZ = 0;
+		bbox_matrix[0][0] = bbox_matrix[1][1] = 1.0;
+		bbox_matrix[0][1] = bbox_matrix[1][0] = 0.0;
+		bbox_scaled = bbox_rotated = False;
 		break;
 
 	    case EOP:
@@ -2355,7 +2718,7 @@
 	    case RIGHT2:
 	    case RIGHT3:
 	    case RIGHT4:
-		DVI_H += DIR * xspell_conv(xsnum(fp, ch - RIGHT1 + 1));
+		moveH(DIR, xspell_conv(xsnum(fp, ch - RIGHT1 + 1)));
 		break;
 
 	    case W1:
@@ -2364,7 +2727,7 @@
 	    case W4:
 		WW = xspell_conv(xsnum(fp, ch - W0));
 	    case W0:
-		DVI_H += DIR * WW;
+		moveH(DIR, WW);
 		break;
 
 	    case X1:
@@ -2373,15 +2736,14 @@
 	    case X4:
 		XX = xspell_conv(xsnum(fp, ch - X0));
 	    case X0:
-		DVI_H += DIR * XX;
+		moveH(DIR, XX);
 		break;
 
 	    case DOWN1:
 	    case DOWN2:
 	    case DOWN3:
 	    case DOWN4:
-		DVI_V += xspell_conv(xsnum(fp, ch - DOWN1 + 1));
-		PXL_V = pixel_conv(DVI_V);
+		moveV(1, xspell_conv(xsnum(fp, ch - DOWN1 + 1)));
 		break;
 
 	    case Y1:
@@ -2390,8 +2752,7 @@
 	    case Y4:
 		YY = xspell_conv(xsnum(fp, ch - Y0));
 	    case Y0:
-		DVI_V += YY;
-		PXL_V = pixel_conv(DVI_V);
+		moveV(1, YY);
 		break;
 
 	    case Z1:
@@ -2400,8 +2761,7 @@
 	    case Z4:
 		ZZ = xspell_conv(xsnum(fp, ch - Z0));
 	    case Z0:
-		DVI_V += ZZ;
-		PXL_V = pixel_conv(DVI_V);
+		moveV(1, ZZ);
 		break;
 
 	    case FNT1:
@@ -2448,6 +2808,11 @@
 		dvi_fmt_error("%s:%d: draw_part: shouldn't happen: %s encountered",
 			      __FILE__, __LINE__, dvi_table2[ch - (FNTNUM0 + 64)]);
 		break;
+#ifdef PTEX
+	    case TDIR:
+		TATE = xone(fp);
+		break;
+#endif /* PTEX */
 
 	    default:
 		dvi_fmt_error("%s:%d: draw_part: unknown op-code %d", __FILE__, __LINE__, ch);
@@ -3240,7 +3605,15 @@
     last_dvi_h1 = DVI_H;
     last_u_glyph = u_glyph;
     last_pxl_v = pxl_v1;
+#ifdef PTEX
+    if (currinf.fontp->flags & FONT_KANJI) {
+    last_dvi_h2 = DVI_H + currinf.fontp->kglyph[ch]->dvi_adv;
+    } else {
+#endif /* PTEX */
     last_dvi_h2 = DVI_H + currinf.fontp->glyph[ch].dvi_adv;
+#ifdef PTEX
+    }
+#endif /* PTEX */
     last_x = x2;
 }
 
@@ -3299,25 +3672,56 @@
 	}
 #ifdef TEXXET
 	if (geom_scan_frame == NULL) {
-	    long dvi_h_sav = DVI_H;
-	    if (currinf.dir < 0)
-		DVI_H -= g->dvi_adv;
+	    DEFINE_POSITION_VAL;
+	    PUSH_POSITION;
+	    if (! TATE && currinf.dir < 0)
+		moveH(1, -g->dvi_adv);
 #endif
 	    x = G_PXL_H - g->x;
 	    y = PXL_V - g->y;
 	    do_char(ch, currinf, info, PXL_V, y, x, x + g->bitmap.w - 1, g);
 #ifdef TEXXET
-	    DVI_H = dvi_h_sav;
+	    POP_POSITION;
 	}
 #endif
 	return DIR * g->dvi_adv;
     }
+#ifdef PTEX
+    else if (currinf.set_char_p == set_char2) {
+	struct glyph *g;
+	long x, y;
+
+	g = currinf.fontp->kglyph[ch];
+	if (g == NULL || g->bitmap.bits == NULL) {
+	    (*currinf.fontp->read_char)(currinf.fontp, ch);
+	    g = currinf.fontp->kglyph[ch];
+	    free_bitmap2(g);
+	    g->tdir = currinf.fontp->dir;
+	}
+
+#ifdef TEXXET
+	if (geom_scan_frame == NULL) {
+	    DEFINE_POSITION_VAL;
+	    PUSH_POSITION;
+	    if (! TATE && currinf.dir < 0)
+		moveH(1, -g->dvi_adv);
+#endif
+	    x = G_PXL_H - g->x;
+	    y = PXL_V - g->y;
+	    do_char(ch, currinf, info, PXL_V, y, x, x + g->bitmap.w - 1, g);
+#ifdef TEXXET
+	    POP_POSITION;
+	}
+#endif
+	return DIR * g->dvi_adv;
+    }
+#endif /* PTEX */
     else if (currinf.set_char_p == set_vf_char) {
 	struct macro *m;
 	struct drawinf oldinfo;
 	wide_ubyte oldmaxchar;
 #ifdef TEXXET
-	long dvi_h_sav;
+	DEFINE_POSITION_VAL;
 #endif
 
 	if (ch > maxchar)
@@ -3325,9 +3729,9 @@
 	if ((m = &currinf.fontp->macro[ch])->pos == NULL)
 	    return 0;	/* catch the error later */
 #ifdef TEXXET
-	dvi_h_sav = DVI_H;
-	if (currinf.dir < 0)
-	    DVI_H -= m->dvi_adv;
+	PUSH_POSITION;
+	if (! TATE && currinf.dir < 0)
+	    moveH(1, -m->dvi_adv);
 	if (geom_scan_frame == NULL) {
 #endif
 	    oldinfo = currinf;
@@ -3343,7 +3747,7 @@
 	    currinf = oldinfo;
 	    maxchar = oldmaxchar;
 #ifdef TEXXET
-	    DVI_H = dvi_h_sav;
+	    POP_POSITION;
 	}
 #endif
 	return DIR * m->dvi_adv;
@@ -3359,13 +3763,14 @@
 	if (status == FAILURE_BLANK)
 	    return 0;
 	if (geom_scan_frame == NULL) {
-	    long dvi_h_sav = DVI_H;
-	    if (currinf.dir < 0)
-		DVI_H -= g->dvi_adv;
+	    DEFINE_POSITION_VAL;
+	    PUSH_POSITION;
+	    if (! TATE && currinf.dir < 0)
+		moveH(1, -g->dvi_adv);
 	    x = G_PXL_H - g->x;
 	    y = PXL_V - g->y;
 	    do_char(ch, currinf, info, PXL_V, y, x, x + g->bitmap.w - 1, g);
-	    DVI_H = dvi_h_sav;
+	    POP_POSITION;
 	}
 #else
 	g = get_t1_glyph(ch, &status, True);
@@ -3385,6 +3790,11 @@
     return 0;
 }
 
+#define xmoveH(dir,dx)   \
+	do { moveH(dir,dx); PXL_V = xpixel_conv(DVI_V); } while(0)
+#define xmoveV(dir,dy)   \
+	do { moveV(dir,dy); PXL_V = xpixel_conv(DVI_V); } while(0)
+
 /*
  *	Handle a character in geometric scanning routine.
  */
@@ -3445,27 +3855,58 @@
 	}
 #ifdef TEXXET
 	if (geom_scan_frame == NULL) {
-	    long dvi_h_sav = DVI_H;
-	    if (currinf.dir < 0)
-		DVI_H -= g->dvi_adv;
+	    DEFINE_POSITION_VAL;
+	    PUSH_POSITION;
+	    if (! TATE && currinf.dir < 0)
+		moveH(1, -g->dvi_adv);
 #endif
 	    x = G_PXL_H - g->x;
 	    y = PXL_V - g->y;
 	    g_info->geom_box(info, x, y,
 			     x + g->bitmap.w - 1, y + g->bitmap.h - 1);
+#ifdef TEXXET
+	    POP_POSITION;
+	}
+#endif
+	return DIR * g->dvi_adv;
+    }
+#ifdef PTEX
+    else if (currinf.set_char_p == set_char2) {
+	struct glyph *g;
+	long x, y;
+
+	g = currinf.fontp->kglyph[ch];
+	if (g == NULL || g->bitmap.bits == NULL) {
+	    (*currinf.fontp->read_char)(currinf.fontp, ch);
+	    g = currinf.fontp->kglyph[ch];
+	    free_bitmap2(g);
+	    g->tdir = currinf.fontp->dir;
+	}
 
 #ifdef TEXXET
-	    DVI_H = dvi_h_sav;
+	if (geom_scan_frame == NULL) {
+	    DEFINE_POSITION_VAL;
+	    PUSH_POSITION;
+	    if (! TATE && currinf.dir < 0)
+		moveH(1, -g->dvi_adv);
+#endif
+	    x = G_PXL_H - g->x;
+	    y = PXL_V - g->y;
+	    g_info->geom_box(info, x, y,
+			     x + g->bitmap.w - 1, y + g->bitmap.h - 1);
+#ifdef TEXXET
+	    POP_POSITION;
 	}
 #endif
 	return DIR * g->dvi_adv;
     }
+#endif /* PTEX */
     else if (currinf.set_char_p == set_vf_char) {
 	struct macro *m;
 	struct drawinf oldinfo;
 	wide_ubyte oldmaxchar;
 #ifdef TEXXET
-	long dvi_h_sav;
+	DEFINE_POSITION_VAL;
 #endif
 
 	if (ch > maxchar)
@@ -3473,9 +3914,9 @@
 	if ((m = &currinf.fontp->macro[ch])->pos == NULL)
 	    return 0;	/* catch the error later */
 #ifdef TEXXET
-	dvi_h_sav = DVI_H;
-	if (currinf.dir < 0)
-	    DVI_H -= m->dvi_adv;
+	PUSH_POSITION;
+	if (! TATE && currinf.dir < 0)
+	    moveH(1, -m->dvi_adv);
 	if (geom_scan_frame == NULL) {
 #endif
 	    oldinfo = currinf;
@@ -3491,7 +3932,7 @@
 	    currinf = oldinfo;
 	    maxchar = oldmaxchar;
 #ifdef TEXXET
-	    DVI_H = dvi_h_sav;
+	    POP_POSITION;
 	}
 #endif
 	return DIR * m->dvi_adv;
@@ -3507,14 +3948,15 @@
 	if (status == FAILURE_BLANK)
 	    return 0;
 	if (geom_scan_frame == NULL) {
-	    long dvi_h_sav = DVI_H;
-	    if (currinf.dir < 0)
-		DVI_H -= g->dvi_adv;
+	    DEFINE_POSITION_VAL;
+	    PUSH_POSITION;
+	    if (! TATE && currinf.dir < 0)
+		moveH(1, -g->dvi_adv);
 	    x = G_PXL_H - g->x;
 	    y = PXL_V - g->y;
 	    g_info->geom_box(info, x, y,
 			     x + g->bitmap.w - 1, y + g->bitmap.h - 1);
-	    DVI_H = dvi_h_sav;
+	    POP_POSITION;
 	}
 #else
 	g = get_t1_glyph(ch, &status, False);
@@ -3543,21 +3985,35 @@
 geom_do_rule(struct scan_info *info, long h, long w)
 {
     long x, y;
+    struct geom_info *g_info = info->data;
 #ifdef TEXXET
-    long dvi_h_save = DVI_H;
+    DEFINE_POSITION_VAL;
+    PUSH_POSITION;
 #endif
-    struct geom_info *g_info = info->data;
-    
+
+    if (bbox_rotated) {
+	fprintf(stderr, "geom_do_rotated_rule(h, w) is not implemented!\n");
+	return;
+    }
+    h = h * bbox_matrix[1][1];
+    w = w * bbox_matrix[0][0];
+
 #ifdef TEXXET
-    if (currinf.dir < 0)
-	DVI_H -= w - 1;
+    if (! TATE && currinf.dir < 0)
+	moveH(1, - w + 1);
 #endif
     x = G_PXL_H;
     y = PXL_V;
+#ifdef PTEX
+    if (TATE)
+	g_info->geom_box(info, x, y, x + xpixel_round(h) - 1,
+			 y + xpixel_round(w) - 1);
+    else
+#endif /* PTEX */
     g_info->geom_box(info, x, y - xpixel_round(h) + 1,
 		     x + xpixel_round(w) - 1, y);
 #ifdef TEXXET
-    DVI_H = dvi_h_save;
+    POP_POSITION;
 #endif
 }
 
@@ -3587,7 +4043,7 @@
     for (;;) {
 	ch = xone(fp);
 	if (ch <= (ubyte)(SETCHAR0 + 127))
-	    DVI_H += char_proc(fp, info, ch);
+	    xmoveH(1, char_proc(fp, info, ch));
 	else if (FNTNUM0 <= ch && ch <= (ubyte) (FNTNUM0 + 63)) {
 	    change_font((unsigned long)(ch - FNTNUM0));
 	}
@@ -3599,7 +4055,7 @@
 	    case PUT1:
 		a = char_proc(fp, info, xone(fp));
 		if (ch != PUT1)
-		    DVI_H += a;
+		    xmoveH(1, a);
 		break;
 
 	    case SET2:
@@ -3613,7 +4069,7 @@
 #else
 		    a = char_proc(fp, info, xnum(fp, 2));
 		    if (ch != PUT2)
-			DVI_H += a;
+			xmoveH(1, a);
 #endif
 		}
 		break;
@@ -3633,7 +4089,7 @@
 		    if (info->geom_special != NULL)
 			geom_do_rule(info, xspell_conv(a), b);
 		}
-		DVI_H += DIR * b;
+		moveH(DIR, b);
 		break;
 
 	    case PUTRULE:
@@ -3754,7 +4210,7 @@
 	    case RIGHT2:
 	    case RIGHT3:
 	    case RIGHT4:
-		DVI_H += DIR * xspell_conv(xsnum(fp, ch - RIGHT1 + 1));
+		xmoveH(DIR, xspell_conv(xsnum(fp, ch - RIGHT1 + 1)));
 		break;
 
 	    case W1:
@@ -3763,7 +4219,7 @@
 	    case W4:
 		WW = xspell_conv(xsnum(fp, ch - W0));
 	    case W0:
-		DVI_H += DIR * WW;
+		xmoveH(DIR, WW);
 		break;
 
 	    case X1:
@@ -3772,15 +4228,14 @@
 	    case X4:
 		XX = xspell_conv(xsnum(fp, ch - X0));
 	    case X0:
-		DVI_H += DIR * XX;
+		xmoveH(DIR, XX);
 		break;
 
 	    case DOWN1:
 	    case DOWN2:
 	    case DOWN3:
 	    case DOWN4:
-		DVI_V += xspell_conv(xsnum(fp, ch - DOWN1 + 1));
-		PXL_V = xpixel_conv(DVI_V);
+		xmoveV(1, xspell_conv(xsnum(fp, ch - DOWN1 + 1)));
 		break;
 
 	    case Y1:
@@ -3789,8 +4244,7 @@
 	    case Y4:
 		YY = xspell_conv(xsnum(fp, ch - Y0));
 	    case Y0:
-		DVI_V += YY;
-		PXL_V = xpixel_conv(DVI_V);
+		xmoveV(1, YY);
 		break;
 
 	    case Z1:
@@ -3799,8 +4253,7 @@
 	    case Z4:
 		ZZ = xspell_conv(xsnum(fp, ch - Z0));
 	    case Z0:
-		DVI_V += ZZ;
-		PXL_V = xpixel_conv(DVI_V);
+		xmoveV(1, ZZ);
 		break;
 
 	    case FNT1:
@@ -3837,6 +4290,12 @@
 		xskip(fp, a + (long)xone(fp));
 		break;
 
+#ifdef PTEX
+	    case TDIR:
+		TATE = xone(fp);
+		break;
+#endif /* PTEX */
+
 #ifndef TEXXET
 	    case SREFL:
 	    case EREFL:
@@ -5062,7 +5521,9 @@
     } while (0);
     
     if (filename != NULL) {
-	return T1_LoadEncoding(filename);
+        char **ret = T1_LoadEncoding(filename);
+        free(filename);
+	return ret;
     }
     return NULL;
 }
@@ -5729,7 +6190,7 @@
     Boolean found_no_map_files = True;
     
     if (file == NULL)
-	file = "xdvi.cfg";
+	file = "pxdvi.cfg";
     
     filename = kpse_find_file(file, kpse_program_text_format, 1);
     if (filename == NULL) {
@@ -5802,6 +6263,21 @@
 	    }
 	    i = new_encoding(enc, ptr);
 	    TRACE_T1((stderr, "Encoding[%d]: '%s' = '%s' -> '%s'", i, enc, name, ptr));
+	}
+	else if (strcmp(keyword, "ptexmap") == 0) {
+	    if ((ptr = strtok(NULL, delim)) == NULL) {
+		XDVI_WARNING((stderr, "Syntax error in entry \"%s\"", buffer));
+		continue;
+	    }
+	    read_ptexmap_file(ptr);
+	}
+	else if (strcmp(keyword, "replace") == 0) {
+	    if ((name = strtok(NULL, delim)) == NULL ||
+                (ptr  = strtok(NULL, delim)) == NULL) {
+		XDVI_WARNING((stderr, "Syntax error in entry \"%s\"", buffer));
+		continue;
+	    }
+	    add_replace_dictionary(name, ptr);
 	} else {
 	    /* again, nag them with a popup so that they'll do something about this ... */
 	    popup_message(globals.widgets.top_level,
diff -udNr xdvik//dvi-draw.h pxdvik//dvi-draw.h
--- xdvik//dvi-draw.h	2006-01-18 06:41:51.000000000 +0900
+++ pxdvik//dvi-draw.h	2010-07-25 14:56:37.634074578 +0900
@@ -82,6 +82,11 @@
 #define XX      currinf.data.x
 #define YY      currinf.data.y
 #define ZZ      currinf.data.z
+#ifdef PTEX
+#define TATE    currinf.data.tdir
+#else /* !PTEX */
+#define TATE    False
+#endif /* !PTEX */
 
 extern void draw_page(void);
 extern void source_reverse_search(int, int, wide_bool);
@@ -131,6 +136,13 @@
 			       wide_ubyte cmd,
 #endif
 			       wide_ubyte ch);
+#ifdef PTEX
+extern setcharRetvalT set_char2(
+#ifdef TEXXET
+				wide_ubyte cmd,
+#endif
+				wide_ubyte ch);
+#endif /* PTEX */
 extern setcharRetvalT load_n_set_char(
 #ifdef TEXXET
 				      wide_ubyte cmd,
diff -udNr xdvik//dvi-init.c pxdvik//dvi-init.c
--- xdvik//dvi-init.c	2009-11-10 19:28:49.000000000 +0900
+++ pxdvik//dvi-init.c	2010-07-25 14:56:37.638074508 +0900
@@ -31,6 +31,8 @@
 
 #include "dvi-init.h"
 #include "dvi-draw.h"
+#include "zeit.h"
+#include "ptexmap.h"
 #include "util.h"
 #include "x_util.h"
 #include "exit-handlers.h"
@@ -74,6 +76,10 @@
 #define	VF_PRE		247
 #define	VF_ID_BYTE	202
 #define	VF_MAGIC	((VF_PRE << 8) | VF_ID_BYTE)
+#ifdef PTEX
+#define	JFMS_MAGIC	11
+#define	JFMS_TATEMAGIC	9
+#endif /* PTEX */
 
 /* font stuff */
 struct font *tn_table[TNTABLELEN];
@@ -177,8 +183,22 @@
 delete_glyphs(struct font *fontp)
 {
     struct glyph *g;
+#ifdef PTEX
+    int n, maxchar;
 
+    maxchar = (fontp->flags & FONT_KANJI) ? KTABLESIZE : fontp->maxchar + 1;
+    for (n = 0; n < maxchar; ++n) {
+	g = (fontp->flags & FONT_KANJI) ? fontp->kglyph[n] : &fontp->glyph[n];
+	if (g == NULL) continue;
+#else /* !PTEX */
     for (g = fontp->glyph; g <= fontp->glyph + fontp->maxchar; ++g) {
+#endif /* !PTEX */
+	free_bitmap2(g);
+    }
+}
+
+void free_bitmap2(struct glyph *g) {
+    {
 	if (g->bitmap2.bits) {
 	    free(g->bitmap2.bits);
 	    g->bitmap2.bits = NULL;
@@ -251,7 +271,23 @@
 		}
 		else {
 		    delete_glyphs(fontp);
+#ifdef PTEX
+		    if (fontp->flags & FONT_KANJI) {
+			int n;
+			for (n = 0; n < KTABLESIZE; ++n) {
+			    if (fontp->kglyph[n] != NULL) {
+				free(fontp->kglyph[n]);
+			    }
+			}
+			free(fontp->kglyph);
+		    }
+		    else {
+#endif /* PTEX */
 		    free((char *)fontp->glyph);
+		    fontp->glyph = NULL;
+#ifdef PTEX
+		    }
+#endif /* PTEX */
 		}
 		free((char *)fontp);
 	    }
@@ -292,7 +328,11 @@
 	struct glyph *g;
 
 	for (f = font_head; f != NULL; f = f->next)
-	    if ((f->flags & FONT_LOADED) && !(f->flags & FONT_VIRTUAL))
+	    if ((f->flags & FONT_LOADED) && !(f->flags & FONT_VIRTUAL)
+#ifdef PTEX
+		&& !(f->flags & FONT_KANJI)
+#endif /* PTEX */
+		)
 		for (g = f->glyph; g <= f->glyph + f->maxchar; ++g)
 		    g->fg = NULL;
     }
@@ -415,6 +455,10 @@
      * appear before the main window comes up ...
      */
 
+#ifdef PTEX
+    fontp->dir = 0;
+#endif /* PTEX */
+
     fontp->file = font_open(
 #if DELAYED_MKTEXPK
 			    load_font_now,
@@ -486,6 +530,12 @@
     fontp->fsize = size_found;
     fontp->timestamp = ++current_timestamp;
     fontp->maxchar = maxchar = 255;
+#ifdef PTEX
+    if (iskanjifont(fontp->fontname)) {
+	fontp->flags |= FONT_KANJI;
+	fontp->set_char_p = set_char2;
+    } else
+#endif /* PTEX */
     fontp->set_char_p = set_char;
     magic = get_bytes(fontp->file, 2);
 
@@ -504,6 +554,13 @@
 	else
 	    (void)read_VF_index(fontp, (wide_bool)hushcs);
 	break;
+#ifdef PTEX
+    case JFMS_MAGIC:
+    case JFMS_TATEMAGIC:
+	fontp->dir = (magic == JFMS_TATEMAGIC);
+	read_ZEIT_index(fontp);
+	return True;
+#endif /* PTEX */
     default:
 	XDVI_FATAL((stderr, "Cannot recognize format for font file %s", fontp->filename));
 	break;
@@ -751,7 +808,13 @@
 	TRACE_FILES((stderr, "process_preamble: fp = %p, errflag = %d, returning False", (void *)fp, *errflag));
 	return False;
     }
-    if (get_byte(fp) != 2) {
+#ifdef PTEX
+    k = get_byte(fp);
+    if (k != 2 && k != 3)
+#else /* !PTEX */
+    if (get_byte(fp) != 2)
+#endif /* !PTEX */
+    {
 	*errflag = WRONG_DVI_VERSION;
 	TRACE_FILES((stderr, "process_preamble: fp = %p, errflag = %d, returning False", (void *)fp, *errflag));
 	return False;
@@ -813,7 +876,12 @@
 	fseek(fp, --pos, SEEK_SET);
 	byte = get_byte(fp);
     }
-    if (byte != 2) {
+#ifdef PTEX
+    if (byte != 2 && byte != 3)
+#else /* !PTEX */
+    if (byte != 2)
+#endif /* !PTEX */
+    {
 	*errflag = WRONG_DVI_VERSION;
 	TRACE_FILES((stderr, "find_postamble: returning FALSE"));
 	return False;
diff -udNr xdvik//dvi-init.h pxdvik//dvi-init.h
--- xdvik//dvi-init.h	2008-07-02 00:42:36.000000000 +0900
+++ pxdvik//dvi-init.h	2010-07-25 14:56:37.638074508 +0900
@@ -95,6 +95,12 @@
     char *pixmap2_gc2;	    /* separate image data for drawing image to globals.gc.fore2 */
 #endif /* GREY */
     struct bitmap bitmap2;  /* shrunken bitmap for character */
+#ifdef PTEX
+    int     tdir;
+#endif /* PTEX */
+    short x3, y3;		/* x and y offset in pixels (backup) */
+    struct bitmap bitmap3;	/* bitmap for character (backup) */
+    float matrix[2][2];
 };
 
 /*
@@ -126,6 +132,9 @@
 #define	FONT_IN_USE	1	/* used for housekeeping */
 #define	FONT_LOADED	2	/* if font file has been read */
 #define	FONT_VIRTUAL	4	/* if font is virtual */
+#ifdef PTEX
+#define	FONT_KANJI	8	/* if font is kanji */
+#endif
 
 /* forward declarations */
 struct font;
@@ -151,6 +160,11 @@
     struct glyph *glyph;
     /* these fields are used by (loaded) virtual fonts */
     struct font **vf_table;	/* list of fonts used by this vf */
+#ifdef PTEX
+    struct glyph **kglyph;
+    int ft2_index;
+    int dir;
+#endif /* PTEX */
     struct tn *vf_chain;	/* ditto, if TeXnumber >= VFTABLELEN */
     struct font *first_font;	/* first font defined */
     struct macro *macro;
@@ -166,6 +180,7 @@
 };
 
 
+extern void free_bitmap2(struct glyph *g);
 extern void reset_fonts(void);
 #if COLOR
 extern void reset_colors(void);
diff -udNr xdvik//dvi.h pxdvik//dvi.h
--- xdvik//dvi.h	2006-01-18 06:41:51.000000000 +0900
+++ pxdvik//dvi.h	2010-07-25 14:56:37.638074508 +0900
@@ -61,4 +61,8 @@
 #define	SREFL		250
 #define	EREFL		251
 
+#ifdef PTEX
+#define TDIR            255
+#endif  /* PTEX */
+
 #define	TRAILER		223	/* Trailing bytes at end of file */
diff -udNr xdvik//dvisel.c pxdvik//dvisel.c
--- xdvik//dvisel.c	2008-07-02 00:42:36.000000000 +0900
+++ pxdvik//dvisel.c	2010-07-25 14:56:37.638074508 +0900
@@ -28,6 +28,7 @@
 #include <string.h>
 #include <ctype.h>
 
+#include "xdvi-config.h"
 #include "dvi.h"
 #include "pagesel.h"
 #include "dvisel.h"
